import Vue from 'vue'
const orderMixins = {
    data() {
        return {
            params: {
                payType:'LARGE',
                payAmount:'',
                shopOrderId:0, 
                orderId: 0, 
                userId: 0 ,
            },
            bigPayInfo: { // 银联转账信息
                orderNo: '',// 订单编号
                shopOrderId: '',// 子订单编号
                bankName: '',// 收款网点
                bankNumber: '',// 收款账号
                receiverName: '' // 收款账户名
            },
            obligation:''
        }
    },
    computed: {
       
    },
    methods: {
        async getPayOrderInfo(shopOrderId) {
            //初始化支付信息
            try {
                const { data } = await this.PayService.PayOrderCheckoutShoporders({ shopOrderId: shopOrderId })
                this.obligation = data.shopOrder.obligation // 待付金额
                this.params.shopOrderId = this.bigPayInfo.shopOrderId = shopOrderId // 子订单Id
                this.params.userId = data.shopOrder.userId // 子订单Id
                this.params.orderId = data.shopOrder.orderId // 主订单Id
                this.bigPayInfo.orderNo = data.shopOrder.orderNo
                this.params.payAmount = this.toFixedFn(this.obligation) // 自定义金额
                if (data.bankInfo) {
                    this.bigPayInfo.bankNumber = data.bankInfo.bankNumber
                    this.bigPayInfo.receiverName = data.bankInfo.receiverName
                    this.bigPayInfo.bankName = data.bankInfo.bankName
                    this.$parent.isBigPayModal = true
                    this.$parent.bigPayInfo = this.bigPayInfo
                }else{
                    this.PayOrderLarge()
                }
            } catch (error) {
                console.log(error)
            }
        },
        // 调用获取银联转账账号
        async PayOrderLarge(){
            try {
                const { data } = await this.PayService.PayOrderLarge(this.params)
                this.bigPayInfo.bankNumber = data.rt9_largePaymentNo
                this.bigPayInfo.receiverName = data.rt10_receiverName
                this.bigPayInfo.bankName = data.rt11_bankName
                this.$parent.bigPayInfo = this.bigPayInfo
                this.$parent.isBigPayModal = true
            } catch (error) {
                console.log(error)
            }
        },
        toFixedFn(value) {
            //处理小数点后两位数
            return Number(value).toFixed(2)
        },
    }
}

export default orderMixins
