// 收银台
import Vue from 'vue'
const cardMixins = {
    data() {
        return {
            popupShow: false, // 控制支付记录弹窗
            popupShow1: false, // 控制快捷支付银行弹窗
            tabCurrentIndex: 0,
            weChatFlag: false, // 微信支付开关
            B2BpayFlag: false, //企业网银支付开关
            QuickPayFlag: false, // 快捷支付开发
            cardsList:[],//查看银行列表
            defaultCards: null,
        }
    },
    filters:{
        bankNumeberFilter(value){
            return value.substring(value.length-4,value.length)
        }
    },
    computed: {
        showWeChatPayMode() {
            return this.weChatFlag
        },
        showB2BpayMode() {
            return this.B2BpayFlag
        },
        showQuickpayMode() {
            return this.QuickPayFlag
        },
        btnColor(){
            const colorMap = {
                0: '#0ABC64',
                1: '#007ACC',
                2: '#16AFE8',
                3: 'linear-gradient(90deg, #FF9300 0%, #FF5B00 100%)',
                4: '#004889'
            }
            return colorMap[this.tabCurrentIndex]
        },
        buttonText(){
            const map = {
                0: '微信支付',
                1: '企业网银支付',
                2: '个人网银支付',
                3: '使用银行卡快捷支付',
                4: '银联转账支付'
            }
            return map[this.tabCurrentIndex]
        }
    },
    methods: {
        handleChoiceaCards(data) {
            //选择的银行
            this.tabCurrentIndex = 3
            this.tabClick(3)
            this.defaultCards = data
            this.quickParams = { ...this.quickParams , ...data}
        },
        hanldeShowPopup(index) {
            switch (index) {
            case 0:
                this.popupShow = true
                break
            case 1:
                this.popupShow1 = true
                break
            default:
                break
            }
        },
        tabClick(index) { //tab切换
            this.tabCurrentIndex = index
            switch (index) {
                case 1:
                    this.payType = 1
                    break
                case 2:
                    this.payType = 2
                    break
                case 4:
                    this.payType = 2
                    break
            }
        },
        checkPayMode(range,weChatFlag) {
            // 校验支付模式
            // test range = '4'
            // 1微信 2支付宝 3个人网银 4企业网银 5快捷支付
            if(range){
                if(weChatFlag === '2'){
                    this.weChatFlag =  false
                }else{
                    this.weChatFlag = range.indexOf('1') > -1
                }
                this.B2BpayFlag = range.indexOf('4') > -1
                this.QuickPayFlag = range.indexOf('5') > -1
                // 设置默认支付方式
                if(this.QuickPayFlag){
                    this.tabCurrentIndex = 3
                }else{
                    this.tabCurrentIndex = this.weChatFlag ? 0 : this.B2BpayFlag ? 1 : 2
                }
            }else{
                this.tabCurrentIndex = 2
            }
            this.tabClick(this.tabCurrentIndex)
        }
    }
}

export default cardMixins